import java.util.function.Supplier
import java.util.stream.IntStream
import java.util.stream.Stream
import kotlin.streams.asSequence

fun main() {
    val i = 0

    val supplier = Supplier<Sequence<Int>>{ IntStream.iterate(i){it.inc() }.asSequence()}

    val mengeGeradeZahlen = IntStream.iterate(i){i -> i+2}.asSequence()
    val mengeNatZahlen = IntStream.iterate(i){it.inc() }.asSequence()

    println("NatZahlen " + supplier.get().take(30).joinToString())
    println("GeradeZahlen " + mengeGeradeZahlen.take(30).joinToString())
    println("N auf G: " + supplier.get().map {NaufG(it) }.asSequence().take(30).joinToString())
}

// z.Z: Menge G ist aufzählbar = N -> G surjektiv und berechenbare Prozedur
fun NaufG(n : Int) : Int{
    return 2*n
}