import java.util.stream.DoubleStream
import java.util.stream.IntStream
import kotlin.streams.asSequence
import kotlin.streams.toList

fun main() {

    println(natZahlen(0,10).joinToString())
    println(geradeZahlen(natZahlen(0,10)).joinToString())
    println(ungeradeZahlen(natZahlen(0,10)).joinToString())

    val geradeZ = geradeZahlen(natZahlen(0,10))
    val ungeradeZ = ungeradeZahlen(natZahlen(0,10))
    println(mergeGeradeUngeradeZahlen(geradeZ,ungeradeZ).joinToString())
}

fun natZahlen (von : Int,bis : Int) : Sequence<Int>{
    return IntStream.rangeClosed(von,bis).asSequence()
}

fun geradeZahlen(zahlen : Sequence<Int>): Sequence<Int> {
    return zahlen.filter {
        isEven(it)
    }.asSequence()
}

fun ungeradeZahlen(zahlen : Sequence<Int>) : Sequence<Int> {
    return zahlen.filter {
        isOdd(it)
    }.asSequence()
}

fun mergeGeradeUngeradeZahlen(geradeZahlen : Sequence<Int>, ungeradeZahlen : Sequence<Int>) : Sequence<Int>{
        return (ungeradeZahlen + geradeZahlen).sorted()
        /*val x = geradeZahlen.takeIf {
            isEven(it.first())
        }



        ungeradeZahlen.takeIf {
            isOdd(it.first())
        }*/

}

fun isEven(zahl : Int) : Boolean {
    return zahl % 2 == 0
}

fun isOdd(zahl : Int) : Boolean {
    return zahl % 2 != 0
}