import astern.LexicographicListComparator
import astern.SizeComparator
import java.lang.StringBuilder
import java.util.*
import java.util.stream.IntStream
import java.util.stream.Stream
import kotlin.collections.ArrayList
import kotlin.streams.asSequence

fun main() {
    val maxLaenge = 5
    val aStern = aStern(maxLaenge).joinToString("\n")

    println("A* über {a,b}* bis Länge $maxLaenge :\n $aStern")

}

/*
" eps, 'a', 'b', 'aa', 'ab', 'ba', 'b', 'aaa', 'aab' , 'abb', 'baa', 'bba', 'bbb' "
"  1 ,  2 ,  3 ,  4  ,  5  ,  6  ,  7 ,  8  ,  9    ,  10   ,  11  ,   12 ,   13 "

1 -> ''
2 -> 'a'
3 -> 'b'
 */

fun aStern(bis: Int): Sequence<String> {
    val i = 0
    val items: ArrayList<String> = arrayListOf()
    val itemsA: ArrayList<String> = arrayListOf()
    val itemsB: ArrayList<String> = arrayListOf()
    val mengeNatZahlen = IntStream.iterate(i) { it.inc() }.asSequence()
    var sequences = permutations(items, items.size)



    mengeNatZahlen.take(bis).forEach {
        if (isEven(it)) {
            itemsA.add("a")
            (0 until itemsA.size).forEach { i ->
                try{
                    val newSequenceA = permutations(itemsA + items[i], itemsA.size+1)
                    val newSequenceAB = permutations(itemsB + items[i], itemsB.size+1)
                    println(newSequenceAB.joinToString())
                    sequences += newSequenceA
                    sequences += newSequenceAB
                }catch (e : ArrayIndexOutOfBoundsException){

                }

            }
        } else {
            itemsB.add("b")
            val newSequenceB = permutations(itemsB, itemsB.size)
            val newSequenceBA = permutations(itemsA + itemsB, (itemsA + itemsB).size)
            sequences += newSequenceB
            sequences += newSequenceBA
        }

        // val newSequence = permutations(items, items.size)
        //println(newSequence.distinct().sortedWith(LexicographicListComparator).joinToString())

        //sequences += newSequenceB
        //sequences += newSequence

    }

    var finalSequence = sequenceOf(" ")
    val sequenceOfStrings =
        sequences.distinct()

            .sortedWith(LexicographicListComparator)
            .sortedWith(SizeComparator)

            .map {
                it.toWord()
            }


    finalSequence += sequenceOfStrings

    return finalSequence
}

fun List<Any?>.toWord(): String {
    var retString = ""
    forEach {
        retString += it.toString()
    }
    return retString
}

fun permutations(items: List<Any?>, qty: Int): Sequence<List<Any?>> = sequence {
    if (items.size < qty || qty == 0)
        return@sequence

    val availableIndices = Array<Int?>(items.size, { it })
    val iterators = Array<Iterator<Int>>(qty, { (0 until availableIndices.size).iterator() })
    val accumulator = Array<Int?>(qty, { null })
    var index = 0
    while (index >= 0) {
        if (index >= qty) {
            yield(accumulator.map { i -> items[i!!] }.toList())  // <-- return a permutation
            index--
        } else {
            if (iterators[index].hasNext()) {
                // return the value we took (if any)
                if (accumulator[index] != null) {
                    availableIndices[accumulator[index]!!] = accumulator[index]
                    accumulator[index] = null
                }

                // take the value from available indices and store it
                val selectedIndex = iterators[index].next()
                accumulator[index] = availableIndices[selectedIndex]
                availableIndices[selectedIndex] = null

                if (accumulator[index] != null) {
                    index++
                }
            } else {
                // return the value we took
                if (accumulator[index] != null) {
                    availableIndices[accumulator[index]!!] = accumulator[index]
                    accumulator[index] = null
                }

                // reset iterator
                iterators[index] = (0 until availableIndices.size).iterator()
                index--
            }
        }
    }
}


